﻿Imports System.Text
Public Class Record

    Dim vQuery(), vVars(), vRet2HTML(), vRet3() As String
    Dim lbRet2 As New ListBox
    Dim w As MainWindow
    Public Sub New(w As MainWindow, sHistQuery() As String, sHistVars() As String,
                   sHistResult2() As String, sHistResult3() As String)
        Try
            InitializeComponent()
            vQuery = sHistQuery
            vVars = sHistVars
            vRet2HTML = sHistResult2 ' HTML
            vRet3 = sHistResult3 ' text
            Me.w = w
        Catch ex As Exception

        End Try
    End Sub

    Private Sub Record_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        Try
            For i As Int32 = 0 To vRet3.Length - 1
                Dim item As New ListBoxItem
                item.Content = Replace(vRet3(i), vbCrLf, " | ")
                item.Height = 20
                lbRet3.Items.Add(item)
            Next
            For i As Int32 = 0 To vQuery.Length - 1
                Dim item As New ListBoxItem
                item.Content = vQuery(i)
                item.Height = 20
                lbQuery.Items.Add(item)
            Next
            For i As Int32 = 0 To vVars.Length - 1
                Dim item As New ListBoxItem
                item.Content = vVars(i)
                item.Height = 20
                lbVars.Items.Add(item)
            Next
            For i As Int32 = 0 To vRet2HTML.Length - 1
                Dim item As New ListBoxItem
                item.Content = vRet2HTML(i)
                item.Height = 20
                lbRet2.Items.Add(item)
            Next
        Catch ex As Exception

        End Try
    End Sub


    Private Sub Up_Click(sender As System.Object, e As System.Windows.RoutedEventArgs)
        Try
            Dim i As Int32
            For Each o In lbQuery.SelectedItems
                i = lbQuery.Items.IndexOf(o)
            Next
            If i > 0 Then
                Dim o As Object = lbQuery.Items(i)
                Dim o1 As Object = lbQuery.Items(i - 1)
                lbQuery.Items.RemoveAt(i)
                lbQuery.Items.RemoveAt(i - 1)
                lbQuery.Items.Insert(i - 1, o)
                lbQuery.Items.Insert(i, o1)
                lbQuery.SelectedItem = o
                If i < lbVars.Items.Count Then
                    o = lbVars.Items(i)
                    o1 = lbVars.Items(i - 1)
                    lbVars.Items.RemoveAt(i)
                    lbVars.Items.RemoveAt(i - 1)
                    lbVars.Items.Insert(i - 1, o)
                    lbVars.Items.Insert(i, o1)
                    lbVars.SelectedItem = o
                End If
                If i < lbRet2.Items.Count Then
                    o = lbRet2.Items(i)
                    o1 = lbRet2.Items(i - 1)
                    lbRet2.Items.RemoveAt(i)
                    lbRet2.Items.RemoveAt(i - 1)
                    lbRet2.Items.Insert(i - 1, o)
                    lbRet2.Items.Insert(i, o1)
                    lbRet2.SelectedItem = o
                End If
                If i < lbRet3.Items.Count Then
                    o = lbRet3.Items(i)
                    o1 = lbRet3.Items(i - 1)
                    lbRet3.Items.RemoveAt(i)
                    lbRet3.Items.RemoveAt(i - 1)
                    lbRet3.Items.Insert(i - 1, o)
                    lbRet3.Items.Insert(i, o1)
                    lbRet3.SelectedItem = o
                End If
            End If
        Catch ex As Exception

        End Try
    End Sub
    Private Sub Down_Click(sender As System.Object, e As System.Windows.RoutedEventArgs)
        Try
            Dim i As Int32
            For Each o In lbQuery.SelectedItems
                i = lbQuery.Items.IndexOf(o)
            Next
            If i < lbQuery.Items.Count - 1 Then
                Dim o As Object = lbQuery.Items(i + 1)
                Dim o1 As Object = lbQuery.Items(i)
                lbQuery.Items.RemoveAt(i + 1)
                lbQuery.Items.RemoveAt(i)
                lbQuery.Items.Insert(i, o)
                lbQuery.Items.Insert(i + 1, o1)
                lbQuery.SelectedItem = o1
                If i < lbVars.Items.Count Then
                    o = lbVars.Items(i + 1)
                    o1 = lbVars.Items(i)
                    lbVars.Items.RemoveAt(i + 1)
                    lbVars.Items.RemoveAt(i)
                    lbVars.Items.Insert(i, o)
                    lbVars.Items.Insert(i + 1, o1)
                    lbVars.SelectedItem = o1
                End If
                If i < lbRet2.Items.Count Then
                    o = lbRet2.Items(i + 1)
                    o1 = lbRet2.Items(i)
                    lbRet2.Items.RemoveAt(i + 1)
                    lbRet2.Items.RemoveAt(i)
                    lbRet2.Items.Insert(i, o)
                    lbRet2.Items.Insert(i + 1, o1)
                    lbRet2.SelectedItem = o1
                End If
                If i < lbRet3.Items.Count Then
                    o = lbRet3.Items(i + 1)
                    o1 = lbRet3.Items(i)
                    lbRet3.Items.RemoveAt(i + 1)
                    lbRet3.Items.RemoveAt(i)
                    lbRet3.Items.Insert(i, o)
                    lbRet3.Items.Insert(i + 1, o1)
                    lbRet3.SelectedItem = o1
                End If

            End If
        Catch ex As Exception

        End Try

    End Sub


    Private Sub Del_Click(sender As System.Object, e As System.Windows.RoutedEventArgs)
        Try
            Dim iv(-1) As Int32, i As Int32
            For Each o In lbQuery.SelectedItems
                ReDim Preserve iv(i)
                iv(i) = lbQuery.Items.IndexOf(o)
                i += 1
            Next
            For i = iv.Length - 1 To 0 Step -1
                lbQuery.Items.RemoveAt(iv(i))
                lbVars.Items.RemoveAt(iv(i))
                lbRet2.Items.RemoveAt(iv(i))
                lbRet3.Items.RemoveAt(iv(i))
            Next
        Catch ex As Exception

        End Try
    End Sub

    Private Sub Update_Click(sender As System.Object, e As System.Windows.RoutedEventArgs)
        Try
            Dim i As Int32 = lbQuery.Items.Count - 1
            ReDim vQuery(i), vVars(i), vRet2HTML(i), vRet3(i)
            For i = 0 To lbQuery.Items.Count - 1
                Dim o As Object = lbQuery.Items(i).content
                vQuery(i) = o
                o = lbVars.Items(i).content
                vVars(i) = o
                o = lbRet2.Items(i).content
                vRet2HTML(i) = o
                o = lbRet3.Items(i).content
                vRet3(i) = o
            Next
            w.setsTbQrysTbvar(vQuery, vVars, vRet2HTML, vRet3)
            Me.Close()
        Catch ex As Exception
        End Try
    End Sub

    Private Sub SelectionChanged(sender As Object,
        e As SelectionChangedEventArgs) Handles lbQuery.SelectionChanged, lbVars.SelectionChanged, lbRet3.SelectionChanged
        Try
            Dim src As ListBox = CType(e.Source, ListBox)
            Dim i As Int32 = src.SelectedIndex
            Dim name As String = LCase(src.Name)
            If name <> "lbquery" Then
                lbQuery.SelectedIndex = i
            End If
            If name <> "lbvars" Then
                lbVars.SelectedIndex = i
            End If
            If name <> "lbret2" Then
                lbRet2.SelectedIndex = i
            End If
            If name <> "lbret3" Then
                lbRet3.SelectedIndex = i
            End If
        Catch ex As Exception

        End Try

    End Sub
End Class
